import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.awt.image.*;
import java.io.File;
import javax.imageio.ImageIO;

/**This is the window where things are drawn*/

public class PictureCanvas extends ScaleCanvas implements MouseListener {
    BufferedImage IMAGE;
    DrawMyStuff DRAW;

     public PictureCanvas() {
	 addMouseListener(this);
         IMAGE = new BufferedImage(400,400,BufferedImage.TYPE_INT_RGB);
	 DRAW=new DrawMyStuff();
	 setScales(50,150,100);
     }

    /**This is the main drawing routine.*/

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.drawImage(IMAGE,0,0,null);
      g.setColor(Color.white);
      g.drawString("click left/right to rescale",20,20);
      drawTriangle(g);
   }  

    /**This routine shows how you would draw and transform a
       triangle*/

    public void drawTriangle(Graphics2D g) {
	GeneralPath gp=new GeneralPath();
	gp.moveTo((float)(.1),(float)(.1));
	gp.lineTo((float)(.5),(float)(.5));
	gp.lineTo((float)(.1),(float)(.8));
	gp=transform(gp);
	g.setColor(Color.red);
	g.fill(gp);
	g.setColor(Color.white);
	g.draw(gp);
    }


    /**This starts the drawing method*/
  public boolean doRun() {
	DRAW=new DrawMyStuff(this);
        new Thread(DRAW).start();
	return(true);
    }


    /**Mouse events*/
    public void mousePressed(MouseEvent e) {}
    public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
    public void mouseExited(MouseEvent e) {}  

    /**accepts mouse clicks and rescales*/
 
    public void mouseClicked(MouseEvent e) {
	MouseData J=MouseData.process(e);
	if(J.mode==1) scaleUp(J.X,-1);
	if(J.mode==3) scaleUp(J.X,1);
     }



}



